blob: 20a1b5c5a22ff162ca14d750d9459d32c148348c [file] [log] [blame]
Girish Gowdra64503432020-01-07 10:59:10 +05301#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
17# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
23DOCKER_EXTRA_ARGS ?=
24DOCKER_REGISTRY ?=
25DOCKER_REPOSITORY ?=
26DOCKER_TAG ?= ${VERSION}
27IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}openolt-scale-tester:${DOCKER_TAG}
28
29# Default is GO111MODULE=auto, which will refuse to use go mod if running
30# go less than 1.13.0 and this repository is checked out in GOPATH. For now,
31# force module usage. This affects commands executed from this Makefile, but
32# not the environment inside the Docker build (which does not build from
33# inside a GOPATH).
34export GO111MODULE=on
35
36DOCKER_BUILD_ARGS ?= \
37 ${DOCKER_EXTRA_ARGS} \
38
39.PHONY: docker-build local-protos local-lib-go
40
41# This should to be the first and default target in this Makefile
42help:
43 @echo "Usage: make [<target>]"
44 @echo "where available targets are:"
45 @echo ""
46 @echo "clean : Removes any local filesystem artifacts generated by a build"
47 @echo "distclean : Removes any local filesystem artifacts generated by a build or test run"
48 @echo "build : Build all openolt adapter artifacts"
49 @echo "docker-build : Build openolt adapter docker image"
50 @echo "docker-push : Push the docker images to an external repository"
51 @echo "help : Print this help"
52 @echo "lint : Run all lint targets"
53 @echo "lint-mod : Verify the Go dependencies"
54 @echo "lint-sanity : Run the Go language sanity tests (vet)"
55 @echo "lint-style : Verify the Go standard format of the source"
56 @echo "sca : Runs various SCA through golangci-lint tool"
57 @echo "test : Run unit tests, if any"
58 @echo
59
60## Docker targets
61
62build: docker-build
63
64docker-build: local-protos local-lib-go
65 docker build $(DOCKER_BUILD_ARGS) -t ${IMAGENAME} -f docker/Dockerfile .
66
67docker-push:
68 docker push ${IMAGENAME}
69
70lint-style:
71ifeq (,$(shell which gofmt))
72 go get -u github.com/golang/go/src/cmd/gofmt
73endif
74 @echo "Running style check..."
75 @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
76 if [ ! -z "$$gofmt_out" ]; then \
77 echo "$$gofmt_out" ;\
78 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
79 exit 1 ;\
80 fi
81 @echo "Style check OK"
82
83lint-sanity:
84 @echo "Running sanity check..."
85 @go vet -mod=vendor ./...
86 @echo "Sanity check OK"
87
88lint-mod:
89 @echo "Running dependency check..."
90 @go mod verify
91 @echo "Dependency check OK. Running vendor check..."
92 @git status > /dev/null
93 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
94 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
95 go mod tidy
96 go mod vendor
97 @git status > /dev/null
98 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
99 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
100 @echo "Vendor check OK."
101
102lint: lint-style lint-sanity lint-mod
103
104__GOPATH=$(shell go env GOPATH)
105
106# Rules to automatically install golangci-lint
107GOLANGCI_LINT_TOOL?=$(shell which golangci-lint)
108ifeq (,$(GOLANGCI_LINT_TOOL))
109GOLANGCI_LINT_TOOL=$(__GOPATH)/bin/golangci-lint
110golangci_lint_tool_install:
111 # Same version as installed by Jenkins ci-management
112 # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint
113 curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(__GOPATH)/bin v1.17.0
114else
115golangci_lint_tool_install:
116endif
117
118# Rules to automatically install go-junit-report
119GO_JUNIT_REPORT?=$(shell which go-junit-report)
120ifeq (,$(GO_JUNIT_REPORT))
121GO_JUNIT_REPORT=$(__GOPATH)/bin/go-junit-report
122go_junit_install:
123 go get -u github.com/jstemmer/go-junit-report
124else
125go_junit_install:
126endif
127
128# Rules to automatically install gocover-covertura
129GOCOVER_COBERTURA?=$(shell which gocover-cobertura)
130ifeq (,$(GOCOVER_COBERTURA))
131 @GOCOVER_COBERTURA=$(__GOPATH)/bin/gocover-cobertura
132gocover_cobertura_install:
133 go get -u github.com/t-yuki/gocover-cobertura
134else
135gocover_cobertura_install:
136endif
137
138test: go_junit_install gocover_cobertura_install
139 @mkdir -p ./tests/results
140
141 @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
142 RETURN=$$? ;\
143 $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
144 $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
145 exit $$RETURN
146
147GOLANGCI_LINT_TOOL:=$(shell which golangci-lint)
148sca: golangci_lint_tool_install
149 @mkdir -p ./sca-report
150 golangci-lint run --out-format junit-xml ./... 2>&1 | tee ./sca-report/sca-report.xml
151
152clean:
153
154distclean: clean
155 rm -rf ./sca_report
156
157# end file